<?php // get NTP time - Copyright Henk Reints, 2018-01-16
header('Content-Type: text/javascript');
$domain = 'udp://pool.ntp.org';
$port = 123;
$timeout = 10;
$socket = fsockopen($domain,$port,$errno,$errstr,$timeout);
$mt0 = microtime();
if($socket)
{	stream_set_timeout ($socket,$timeout);
	$response = (fwrite($socket,"\010".str_repeat("\0",47)) ? fread($socket,48) : false);
	$mt1 = microtime();
	fclose($socket);
	$data = ($response ? unpack('N12',$response) : array());
	list($us0,$s0) = explode(' ',$mt0);	$srvtim0_us = (float)$us0;	$srvtim0_s  = (float)$s0;
	list($us1,$s1) = explode(' ',$mt1);	$srvtim1_us = (float)$us1;	$srvtim1_s  = (float)$s1;
?>
// Copyright Henk Reints, 2018-01-16
var ntpURL = "<?=$domain?>:<?=$port?>";	// where to get the atomic time
var ntpRaw = [<?=implode(',',$data)?>];	// raw atomc time data received (full packet)
var ntpEra = Date.UTC(1900,0,1,0,0,0,0);	// start time of NTP era = 1900-01-01T00:00:00.000 (Jauary is month no. 0 in JS)
var ntpDate = new Date(ntpRaw.length < 9 ? NaN : ntpEra+Math.floor((ntpRaw[8]+ntpRaw[9]/0x100000000)*1000));	// convert NTP "receive time" to JS Date
var ntpTime = ntpDate.getTime();	// internal JS Date value thereof (ms since Unix Epoch)
if (ntpTime < 0) ntpDate=new Date(ntpTime+0x100000000*1000);	// if below Unix Epoch then add one NTP Epoch interval (make this future-proof)
var serverTime0 = new Date(Math.floor((<?=$srvtim0_us?>+<?=$srvtim0_s?>)*1000));	// server time (values from PHP microtime) before accessing time server
var serverTime1 = new Date(Math.floor((<?=$srvtim1_us?>+<?=$srvtim1_s?>)*1000));	// server time after accessing time server
<?php
} else
{	list($us0,$s0) = explode(' ',$mt0);	$srvtim0_us = (float)$us0;	$srvtim0_s  = (float)$s0;
?>
// Copyright Henk Reints, 2018-01-16
var ntpURL = "<?=$domain?>:<?=$port?>";	// where to get the atomic time
var ntpDate="<?=$errno?>:<?=$errstr?>";	// error opening socket to time server
var serverTime0 = new Date(Math.floor((<?=$srvtim0_us?>+<?=$srvtim0_s?>)*1000));	// server time (values from PHP microtime)
<?php
};
?>
